
-- # import Property
-- # import CoverPrelude
-- # import GHC.Base
-- # import GHC.List
-- # import Data.Tuple-Types
-- # import Data.Tuple-Constructors

infixr 10 ::
data List (a : Set) : Set where
  nil	      : List a
  (::)	      : a -> List a -> List a
  "List _|_"  : List a

injList' (a : Set)(a' : ISet) : (a -> a') -> List a -> "GHC.Base:[]" a'
injList' i []	      = "GHC.Base.[]"
injList' i (x::xs)      = "GHC.Base.:" (i x) (injList' i xs)
injList' i "List _|_"  = "_|_"

id (a : ISet) : a -> a
id x = x

injList (a : ISet) : List a -> "GHC.Base:[]" a
injList = injList' id

data Pair (a, b : Set) : Set where
  pair	      : a -> b -> Pair a b
  "Pair _|_"  : Pair a b

injPair (a, b : Set)(a', b' : ISet) : (a -> a') -> (b -> b') ->
					 Pair a b -> "Data.Tuple:(,)" a' b'
injPair iA iB (pair x y)  = "Data.Tuple.(,)" (iA x) (iB y)
injPair _ _ "Pair _|_"	  = "_|_"

isTrue : "GHC.Base:Bool" -> Prop
isTrue x = x == "GHC.Base.True"

isReflexiveEq (a : ISet) : "GHC.Base::TEq" a -> Prop
isReflexiveEq {a} eq = (x : a) -> isTrue ("GHC.Base.==" eq x x)

isTotalList (a : Set) : List a -> Prop
isTotalList []		= True
isTotalList (x::xs)	= isTotalList xs
isTotalList "List _|_"	= False

-- Properties of ++ -------------------------------------------------------

(++) (a : ISet) : "GHC.Base:[]" a -> "GHC.Base:[]" a -> "GHC.Base:[]" a
xs ++ ys = "GHC.Base.++" xs ys

"++ assoc" (a : ISet) : (xs : List a) -> (ys, zs : "GHC.Base:[]" a) ->
			  injList xs ++ (ys ++ zs) ==
			  (injList xs ++ ys) ++ zs
"++ assoc" [] ys zs	    = cover-plugin(include "GHC.Base")
"++ assoc" "List _|_" ys zs = cover-plugin(include "GHC.Base")
"++ assoc" (x::xs) ys zs	    = cover-plugin(include "GHC.Base", "++ assoc" xs ys zs)

"++ []" (a : ISet) : (xs : List a) -> injList xs ++ injList [] == injList xs
"++ []" []	    = cover-plugin(include "GHC.Base")
"++ []" "List _|_"  = cover-plugin(include "GHC.Base")
"++ []" (x::xs)	    = cover-plugin(include "GHC.Base", "++ []" xs)

-- Properties of reverse --------------------------------------------------

reverse (a : ISet) : "GHC.Base:[]" a -> "GHC.Base:[]" a
reverse xs = "GHC.List.reverse" xs

{-
rev (a : ISet) : "GHC.Base:[]" a -> "GHC.Base:[]" a -> "GHC.Base:[]" a
rev xs ys = "GHC.List.rev" xs ys

revApp (a : ISet) : (xs : List a) -> (ys : "GHC.Base:[]" a) ->
		      rev (injList xs) ys == reverse (injList xs) ++ ys
revApp []	  = cover-plugin(include "GHC.Base", include "GHC.List")
revApp "List _|_" = cover-plugin(include "GHC.Base", include "GHC.List")
revApp (x::xs)	  = cover-plugin(include "GHC.Base", include "GHC.List", revApp xs)
-}
reverseCons (a : ISet) : (x : a) -> (xs : List a) ->
			   "GHC.List.reverse" (injList (x::xs))
			      ==
			   "GHC.Base.++" ("GHC.List.reverse" (injList xs)) (injList [x])
-- reverseCons x []	  = cover-plugin( include "GHC.Base", include "GHC.List" )
-- reverseCons x "List _|_"  = cover-plugin( include "GHC.Base", include "GHC.List" )
-- reverseCons x (y::ys)	  = cover-plugin( include "GHC.Base", include "GHC.List"
-- 					, reverseCons x ys)
-- 
