
module TypeChecker.Definitions where

import Data.List

import Syntax.Internal
import Syntax.Values

import TypeChecker.Monad
import TypeChecker.UnfoldConstants

import Utils.Map hiding (map, union)
import Utils.Pairs
import Utils.Monads

allDefinitions :: Value -> TC [Name]
allDefinitions v =
    do	v' <- unfoldConstants v
	case vView v' of
	    VId _	  -> return []
	    VBId _	  -> return []
	    VDef x _	  -> return [x]
	    VCon x pa _ _ -> cat $ return [x] : map defs pa
	    VApp v w	  -> cat $ map defs [v,w]
	    VPi v f	  -> cat [defs (unEl v), defabs $ fmap unEl f]
	    VLam f	  -> defabs f
	    VSort _	  -> return []
	    VTop	  -> return []
	    VPair v w	  -> cat $ map defs [v,w]
	    VProj v _	  -> defs v
	    VSigma v f	  -> cat [defs (unEl v), defabs $ fmap unEl f]
	    VMeta _	  -> return []
	    VStruct xs	  -> cat $ map (defs . snd . snd) xs
    where
	cat xs	    = foldr union [] <$> sequence xs
	defs	    = allDefinitions
	defabs f    = defs (absBody f)

