{- Bug: When checking equality we want f x == f y to require x == y, but when
	using equality testing to figure out pattern match argument
	dependencies this is fatal!
   Solution 1:
	Check that indices are on constructor form (variables in the leaves)
	whenever we pattern match.
      Pros: simple, easy to understand restriction
      Cons: excludes some useful cases where the non-constructor part doesn't matter
   Solution 2:
	Make sure that instantiations arising from pattern matching on families
	are ok.
      Pros: this is what we would like
      Cons: difficult to implement(?), at least I don't know how at the moment
-}

data (==){A:Set}(a:A) : A -> Set where
  refl : a == a

data False : Set where

data Bool : Set where
  true, false : Bool

data Wrap (A:Set) : Set where
  wrap : A -> Wrap A

g : Bool -> Bool
g true	= true
g false = true

sym (A:Set)(x,y:A) : x == y -> y == x
sym refl = refl

injG : (x,y:Bool) -> g x == g y -> x == y
injG x x refl = refl

injG' : (x,y:Bool) -> Wrap (g x == g y) -> x == y
injG' x x (wrap refl) = refl

bad : true == false
bad = injG' true false (wrap refl)

